import pygame, random, sys, math
pygame.init()
screen = pygame.display.set_mode([666,666])
clock = pygame.time.Clock()
joker = pygame.image.load("assets/joker.png")
jokeR = joker.get_rect()
sky = pygame.image.load("assets/sky.png")
error = pygame.image.load("assets/error.png")
itemI = pygame.image.load("assets/item.png")
manifesto = pygame.image.load("assets/manifesto.png")
pygame.mixer.music.load('assets/sfx.mp3')
font = pygame.font.SysFont('Comic Sans MS', 30)
theta = 0
thetacc = 0
oop = True
loop = True
mass = 2
runtime = 0.0
points = 0
propa = True
items = []
def left(tick,mass):
	global thetacc
	thetacc -= tick*0.0002/mass
def right(tick,mass):
	global thetacc
	thetacc += tick*0.0002/mass
def up(tick):
	global mass
	if mass + tick*0.001 < 3:
		mass += tick*0.001
def down():
	global mass
	if mass - tick*0.001 > 1:
		mass -= tick*0.001
def pol2cart(phi):
    y = 250 * math.cos(phi)+333
    x = 250 * math.sin(phi)+333
    return(x, y)
def createItem():
	global items
	item=[None, None]
	item[0] = itemI.get_rect(center=(333,333))#rect
	item[1] = (random.random()-0.5, random.random()-0.5)#vect
	items.append(item)
while oop:
	for event in pygame.event.get(): #inputs or whatever
		if event.type == pygame.QUIT:
			pygame.display.quit()
			sys.exit()
		elif event.type == pygame.KEYDOWN:
			if event.key == pygame.K_ESCAPE:
				pygame.display.quit()
				sys.exit()
			if event.key == pygame.K_RETURN:
				oop = False
	screen.blit(error, (0,0))
	pygame.display.flip()
	clock.tick(10)
while loop:
	tick = clock.tick(10)
	runtime += float(tick)/1000
	if runtime > len(items)+1:
		createItem()
	elif runtime > 30:
		loop = False
	for event in pygame.event.get(): #inputs or whatever
		if event.type == pygame.QUIT:
			pygame.display.quit()
			sys.exit()
		elif event.type == pygame.KEYDOWN:
			if event.key == pygame.K_ESCAPE:
				pygame.display.quit()
				sys.exit()
	keys = pygame.key.get_pressed()
	if keys[pygame.K_w]:
		up(tick)
	if keys[pygame.K_a]:
		left(tick,mass)
	if keys[pygame.K_s]:
		down()
	if keys[pygame.K_d]:
		right(tick,mass)
	if abs(theta) > math.pi:
		theta -= 2*theta
	elif theta > 0: #gravity
		thetacc -= tick*0.0001*math.pow(mass,1.41)
	elif theta < 0: #gravity
		thetacc += tick*0.0001*math.pow(mass,1.41)
	if thetacc > 0: #air resistance
		thetacc -= 0.001
	elif thetacc < 0: #air resistance
		thetacc += 0.001
	theta += thetacc
	jokeR.center = pol2cart(theta)
	screen.blit(sky,   (0,0))
	timetext = font.render(str(30-runtime), False, (0, 0, 0))
	screen.blit(timetext,(0,0))
	pointstext = font.render(str(points), False, (0, 0, 0))
	screen.blit(pointstext,(600,0))
	pygame.draw.line(screen, (000,000,000), (333,333), jokeR.center, 10)
	pygame.draw.circle(screen, (100,100,255), (333,333), 10, 0)
	screen.blit(joker, jokeR)
	pygame.draw.circle(screen, (149,94,58), jokeR.center, int(math.pow(mass*5,2)), 1)
	for item in items:
		item[0].move_ip(item[1][0]*tick*0.2,item[1][1]*tick*0.2)
		screen.blit(itemI, item[0])
		if item[0].colliderect(jokeR):
			points += 1
			pygame.mixer.music.play(0)
			item[0].move_ip(700,700)
	pygame.display.flip()
pygame.mixer.music.load('assets/sfxfull.mp3')
pygame.mixer.music.play(0)
screen.blit(manifesto, (0,0))
pygame.display.flip()
while propa:
	clock.tick(20)
	for event in pygame.event.get(): #inputs or whatever
		if event.type == pygame.QUIT:
			pygame.display.quit()
			sys.exit()
		elif event.type == pygame.KEYDOWN:
			if event.key == pygame.K_ESCAPE:
				pygame.display.quit()
				sys.exit()
